<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Title</title>
    <link href="https://fonts.googleapis.com/css?family=Roboto&display=swap" rel="stylesheet">
    <style>
        * {
            font-family: 'Roboto Thin', sans-serif;
        }
        body {
            background-color: black;
            color: white;
        }
        table {
            width: 100%;
        }
        th {
            background-color: maroon;
        }
        tr:nth-child(even) td {
            background-color: #333333;
        }
        th, td {
            padding: 8px;
            text-align: center;
        }
        table, table td, table th {
            border: 1px solid;
            border-collapse: collapse;
        }
        #logout {
            background: #ff4444;
            border: none;
            border-radius: 4px;
            position: absolute;
            top: 5px;
            right: 5px;
            width: 100px;
            padding: 8px 16px;
            color: white;
            cursor: pointer;
        }
        #entryNavigation {
            background: #4444FF;
            border: none;
            border-radius: 4px;
            position: absolute;
            top: 5px;
            right: 120px;
            width: 150px;
            padding: 8px 16px;
            color: white;
            cursor: pointer;
            text-decoration: none;
        }
        /* The Modal (background) */
        .modal {
            display: none; /* Hidden by default */
            position: fixed; /* Stay in place */
            z-index: 1; /* Sit on top */
            padding-top: 100px; /* Location of the box */
            left: 0;
            top: 0;
            width: 100%; /* Full width */
            height: 100%; /* Full height */
            overflow: auto; /* Enable scroll if needed */
            background-color: rgb(0,0,0); /* Fallback color */
            background-color: rgba(0,0,0,0.4); /* Black w/ opacity */
        }

        /* Modal Content */
        .modal-content {
            background-color: #fefefe;
            margin: auto;
            padding: 20px;
            border: 1px solid #888;
            width: 80%;
        }

        /* The Close Button */
        .close {
            color: #aaaaaa;
            float: right;
            font-size: 28px;
            font-weight: bold;
        }

        .close:hover,
        .close:focus {
            color: #000;
            text-decoration: none;
            cursor: pointer;
        }
    </style>
</head>
<body>
    <h1>User</h1>
    <div id="users"></div>
    <br><br><br>
    <form action="#">
        Username:<br>
        <input id="username" type="text" name="username">
        <br>
        Password:<br>
        <input id="password" type="text" name="password">
        <br>
        Team-Id:<br>
        <input id="teamId" type="text" name="teamId">
        <br><br>
        <input type="button" onclick="submitUser()" value="Submit">
    </form>
    <button id="logout">Logout</button>
    <a id="entryNavigation" href="/interface/index.html">Entry-Verwaltung</a>

    <!-- The Modal -->
    <div id="myModal" class="modal">

        <!-- Modal content -->
        <div class="modal-content">
            <span class="close">&times;</span>
            <form action="#">
                Username:<br>
                <input id="updateUsername" type="text" name="username">
                <br>
                Password:<br>
                <input id="updatePassword" type="text" name="password">
                <br>
                Team-Id:<br>
                <input id="updateTeamId" type="text" name="teamId">
                <br><br>
                <input type="button" id="updateEntryButton" onclick="updateEntry()" value="Submit">
            </form>
        </div>

    </div>
    <script>
        function getUsers() {
            var xhttp = new XMLHttpRequest();
            xhttp.onreadystatechange = function() {
                if (this.readyState == 4 && this.status == 200) {
                    var users = JSON.parse(this.responseText);
                    var rootNode = document.getElementById("users");
                    if (users.length === 0) {
                        var noUsersFoundNode = document.createElement("H5");
                        var textNode = document.createTextNode("No Users found");
                        noUsersFoundNode.appendChild(textNode);
                        rootNode.appendChild(noUsersFoundNode);
                    } else {
                        var tableNode = document.createElement("table");
                        tableNode.setAttribute("id", "tableNode");
                        var headerNode = document.createElement("tr");

                        var idHeaderNode = document.createElement("th");
                        var idHeaderTextNode = document.createTextNode("ID");
                        idHeaderNode.appendChild(idHeaderTextNode);
                        headerNode.appendChild(idHeaderNode);

                        var usernameHeaderNode = document.createElement("th");
                        var usernameHeaderTextNode = document.createTextNode("Username");
                        usernameHeaderNode.appendChild(usernameHeaderTextNode);
                        headerNode.appendChild(usernameHeaderNode);

                        var passwordHeaderNode = document.createElement("th");
                        var passwordHeaderTextNode = document.createTextNode("Password");
                        passwordHeaderNode.appendChild(passwordHeaderTextNode);
                        headerNode.appendChild(passwordHeaderNode);

                        var teamIdHeaderNode = document.createElement("th");
                        var teamIdHeaderTextNode = document.createTextNode("Team-ID");
                        teamIdHeaderNode.appendChild(teamIdHeaderTextNode);
                        headerNode.appendChild(teamIdHeaderNode);

                        var deleteHeaderNode = document.createElement("th");
                        var deleteHeaderTextNode = document.createTextNode("Delete User");
                        deleteHeaderNode.appendChild(deleteHeaderTextNode);
                        headerNode.appendChild(deleteHeaderNode);

                        var updateHeaderNode = document.createElement("th");
                        var updateHeaderTextNode = document.createTextNode("Update Entry");
                        updateHeaderNode.appendChild(updateHeaderTextNode);
                        headerNode.appendChild(updateHeaderNode);

                        tableNode.appendChild(headerNode);

                        users.forEach(function(user) {
                            createRow(user, tableNode);
                        });
                        rootNode.appendChild(tableNode);
                    }
                }
            };
            xhttp.open("GET", "/api/users", true);
            xhttp.setRequestHeader("Authorization", "Bearer " + localStorage.getItem("token"));
            xhttp.send();
        }

        function submitUser() {
            var valUsername = document.getElementById("username").value;
            var valPassword = document.getElementById("password").value;
            var valTeamId = document.getElementById("teamId").value;

            var xhttp = new XMLHttpRequest();
            xhttp.onreadystatechange = function() {
                if (this.readyState == 4 && this.status == 200) {
                    location.reload();
                }
            };
            xhttp.open("POST", "/api/users", true);
            xhttp.setRequestHeader("Content-Type", "application/json");
            xhttp.setRequestHeader("Authorization", "Bearer " + localStorage.getItem("token"));
            xhttp.send(JSON.stringify({
                username: valUsername,
                password: valPassword,
                team: {
                    id: valTeamId
                }
            }));
        }

        function deleteUser(id) {
            var xhr = new XMLHttpRequest();
            xhr.onreadystatechange = function() {
                if (this.readyState == 4 && this.status == 200) {
                    location.reload();
                }
            }
            xhr.open("DELETE", "/api/users/" + id, true);
            xhr.setRequestHeader("Authorization", "Bearer " + localStorage.getItem("token"));
            xhr.send();
        }

        function createRow(user, tableNode) {
            var rowNode = document.createElement("tr");
            rowNode.setAttribute("data-id", user.id);

            var idTdNode = document.createElement("td");
            var idTextNode = document.createTextNode(user.id);
            idTdNode.appendChild(idTextNode);
            rowNode.appendChild(idTdNode);

            var usernameTdNode = document.createElement("td");
            var usernameTextNode = document.createTextNode(user.username);
            usernameTdNode.appendChild(usernameTextNode);
            rowNode.appendChild(usernameTdNode);

            var passwordTdNode = document.createElement("td");
            var passwordTextNode = document.createTextNode(user.password);
            passwordTdNode.appendChild(passwordTextNode);
            rowNode.appendChild(passwordTdNode);

            var team = user.team !== null ? user.team : {"id": "-"}
            var teamIdTdNode = document.createElement("td");
            var teamIdTextNode = document.createTextNode(team.id);
            teamIdTdNode.appendChild(teamIdTextNode);
            rowNode.appendChild(teamIdTdNode);

            var deleteTdNode = document.createElement("td");
            var deleteButtonNode = document.createElement("button");
            deleteButtonNode.setAttribute("onclick", "deleteUser(" + user.id + ")");
            var deleteTextNode = document.createTextNode("Delete Me");
            deleteButtonNode.appendChild(deleteTextNode);
            deleteTdNode.appendChild(deleteButtonNode);
            rowNode.appendChild(deleteTdNode);

            var updateTdNode = document.createElement("td");
            var updateButtonNode = document.createElement("button");
            updateButtonNode.setAttribute("onclick", "openUpdateModal(" + user.id + ")");
            var updateTextNode = document.createTextNode("Update Me");
            updateButtonNode.appendChild(updateTextNode);
            updateTdNode.appendChild(updateButtonNode);
            rowNode.appendChild(updateTdNode);

            tableNode.appendChild(rowNode);
        }

        document.getElementById("logout").addEventListener("click", function() {
            localStorage.removeItem("token");
            window.location.replace("/login/index.html");
        })

        window.onload = function() {
            if (localStorage.getItem("token") !== null) {
                getUsers();
            } else {
                window.location.replace("/login/index.html")
            }
        };

        // Get the modal
        var modal = document.getElementById("myModal");

        // Get the <span> element that closes the modal
        var span = document.getElementsByClassName("close")[0];

        // When the user clicks on <span> (x), close the modal
        span.onclick = function() {
            modal.style.display = "none";
        }

        // When the user clicks anywhere outside of the modal, close it
        window.onclick = function(event) {
            if (event.target == modal) {
                modal.style.display = "none";
            }
        }

        function openUpdateModal(id) {
            modal.style.display = "block";
            var row = document.querySelector("[data-id='" + id + "']");
            var originalUsernameValue = row.children[1].textContent;
            var originalPasswordValue = row.children[2].textContent;
            var originalTeamIdValue = row.children[3].textContent;

            document.getElementById("updateEntryButton").setAttribute("data-id", id);

            document.getElementById("updateUsername").value = originalUsernameValue;
            document.getElementById("updatePassword").value = originalPasswordValue;
            document.getElementById("updateTeamId").value = originalTeamIdValue;
        }

        function updateEntry() {
            var valUsername = document.getElementById("updateUsername").value;
            var valPassword = document.getElementById("updatePassword").value;
            var valTeamId = document.getElementById("updateTeamId").value;

            var xhttp = new XMLHttpRequest();
            xhttp.onreadystatechange = function () {
                if (this.readyState == 4 && this.status == 200) {
                    location.reload();
                }
            };
            xhttp.open("PUT", "/api/users/" + document.getElementById("updateEntryButton").getAttribute("data-id"), true);
            xhttp.setRequestHeader("Content-Type", "application/json");
            xhttp.setRequestHeader("Authorization", "Bearer " + localStorage.getItem("token"));
            xhttp.send(JSON.stringify({
                username: valUsername,
                password: valPassword,
                team: {
                    id: valTeamId
                }
            }));
        }
    </script>
</body>
</html>